# SPDX-FileCopyrightText: Copyright © 2023 Idiap Research Institute <contact@idiap.ch>
#
# SPDX-License-Identifier: GPL-3.0-or-later

"""AlexNet."""

from torch import empty
from torch.nn import BCEWithLogitsLoss
from torch.optim import SGD

from ...models.alexnet import Alexnet

# optimizer
optimizer = SGD
optimizer_configs = {"lr": 0.01, "momentum": 0.1}

# criterion
criterion = BCEWithLogitsLoss(pos_weight=empty(1))
criterion_valid = BCEWithLogitsLoss(pos_weight=empty(1))

from ...data.transforms import ElasticDeformation

augmentation_transforms = [
    ElasticDeformation(p=0.8),
]

# model
model = Alexnet(
    criterion,
    criterion_valid,
    optimizer,
    optimizer_configs,
    pretrained=False,
    augmentation_transforms=augmentation_transforms,
)
